<?php
//
// (C) egate media GmbH 2014
//


$oDbAccess = new myDbAccess();
// catch any row - EE all sub-shops have to be same version
$rs = mysql_query("SELECT oxversion FROM oxshops WHERE 1;", $oDbAccess->dbId);
$sVersion = mysql_result($rs, 0, 0);
if ($sVersion >= 4.7)
{
    require_once dirname(__FILE__)."/../../bootstrap.php";
}
else
{
    function getShopBasePath()
    {
        return dirname(__FILE__).'/../../';
    }
    include getShopBasePath().'modules/functions.php';
    require_once getShopBasePath().'core/oxfunctions.php';
    require_once getShopBasePath().'core/adodblite/adodb.inc.php';
}


class processXml extends oxSuperCfg
{
    private $_oDbAccess = null;

    public function start()
    {
        $this->_oDbAccess = new myDbAccess();

        $sPostXml = $_POST['xml'];
        if (get_magic_quotes_gpc())
        {
            $sPostXml = stripslashes($sPostXml);
        }

        $sXml = @simplexml_load_string($sPostXml);

        if ($sXml === false)
        {
            $this->_sendError('12');
        }

        if ($sXml->api_version != '1.0')
        {
            $this->_sendError('1');
        }

        if (strtolower($sXml->rechtstext_language) != 'de')
        {
            $this->_sendError('9');
        }

        if ($sXml->action == 'getaccountlist')
        {
            $this->_sendShopList();
        }
        elseif ($sXml->action == 'push')
        {
            $this->_checkToken($sXml);

            // EM 140521: added utf8_decode
            $sShopId = utf8_decode($sXml->user_account_id);

            // $this->_logProcess("shop ID: $sShopId");

            if (!isset($sShopId) || !$sShopId || !is_numeric($sShopId)) $sShopId = 'oxbaseshop';

            // $this->_logProcess("shop ID: $sShopId");

            if ($sXml->rechtstext_type == 'agb')
            {
                $this->_writeContent($sShopId, 'oxagb', $sXml->rechtstext_html);
            }
            elseif ($sXml->rechtstext_type == 'datenschutz')
            {
                $this->_writeContent($sShopId, 'oxsecurityinfo', $sXml->rechtstext_html);
            }
            elseif ($sXml->rechtstext_type == 'widerruf')
            {
                $this->_writeContent($sShopId, 'oxrightofwithdrawal', $sXml->rechtstext_html);
            }
            elseif ($sXml->rechtstext_type == 'impressum')
            {
                $this->_writeContent($sShopId, 'oximpressum', $sXml->rechtstext_html);
            }
            else
            {
                $this->_sendError('4');  // type not supported
            }

            if ($sXml->rechtstext_pdf_url == '' && ($sXml->rechtstext_type == 'agb' || $sXml->rechtstext_type == 'widerruf'))
            {
                $this->_sendError('7');
            }
            elseif ($sXml->rechtstext_pdf_url != '')
            {
                $this->_savePdf($sXml, $sXml->rechtstext_type);
            }

            $this->_sendSuccess();
        }
        else
        {
            $this->_sendError('10');
        }
    }

    private function _checkToken($sXml)
    {
        // the oxConfig, and so the whole OXID framework, we ONLY need for getShopConfVar and getConfigParam, so everything else we keep doing without oxConfig
        $myConfig  = oxConfig::getInstance();

        // EM 140521: added utf8_decode
        $sAccountId = utf8_decode($sXml->user_account_id);

        // $tmp = strlen($sAccountId);
        // $this->_logProcess("Account ID: $sAccountId - lenght: $tmp ");

        if ($this->_oDbAccess->iUtfMode != '1')
        {
            $sToken = utf8_decode($sXml->user_auth_token);
        }
        else
        {
            $sToken = $sXml->user_auth_token;
        }

        if (!isset($sAccountId) || !$sAccountId)
        {
            $aResult = mysql_query("SELECT COUNT(oxid) FROM oxshops WHERE 1;", $this->_oDbAccess->dbId);
            $aCount  = mysql_fetch_row($aResult);
            $iCount  = $aCount[0];

            // account ID not send and installation has more than one shop we definitely have to issue access error
            if ($iCount > 1)
            {
                mysql_close($this->_oDbAccess->dbId);
                $this->_sendError('11');
            }

            // same if token does not match
            if ($myConfig->getShopConfVar("itrecht_sToken") != $sToken)
            {
                mysql_close($this->_oDbAccess->dbId);
                $this->_sendError('3');
            }
        }
        else
        {
            $aResult = mysql_query("SELECT oxid FROM oxshops WHERE 1;", $this->_oDbAccess->dbId);
            $x       = 0;
            while ($aRow = mysql_fetch_array($aResult))
            {
                $aShops[$x++] = $aRow[0];
            }

            // $tmp1 = $aShops[0];
            // $tmp2 = $aShops[1];
            // $tmp3 = $aShops[2];
            // $this->_logProcess("Account ID: $sAccountId - $tmp1 - $tmp2 - $tmp3 - $x");

            // check if shop ID is valid
            if (!in_array($sAccountId, $aShops))
            {
                mysql_close($this->_oDbAccess->dbId);
                $this->_sendError('11');
            }

            // $tmp1 = $myConfig->getShopConfVar("itrecht_sToken", $sAccountId);
            // $this->_logProcess("Token DB: $tmp1 - Token XML: $sToken ");

            // account ID set, but does not match with token for that sub shop
            if ($myConfig->getShopConfVar("itrecht_sToken", $sAccountId) != $sToken)
            {
                mysql_close($this->_oDbAccess->dbId);
                $this->_sendError('3');
            }
        }
    }

    private function _writeContent($sShopId, $sLoadId, $sText)
    {
        $oLang      = oxLang::getInstance();
        $aLanguages = $oLang->getLanguageArray();
        foreach ($aLanguages as $sKey => $aRow)
        {
            $sLangId = $sKey;
            // hard coded de for now - easy to change later
            if (strtolower($aRow->abbr) == 'de')
            {
                break;
            }
        }
        if ($sLangId > 0)
        {
            $sField = 'oxcontent'.'_'.$sLangId;
        }
        else
        {
            $sField = 'oxcontent';
        }

        if ($this->_oDbAccess->iUtfMode != '1')
        {
            $sText = utf8_decode($sText);
        }

        if (strlen($sText) < 50)
        {
            $this->_sendError('6');
        }

        mysql_query("UPDATE oxcontents SET $sField = '$sText' WHERE oxshopid = '$sShopId' and oxloadid = '$sLoadId'", $this->_oDbAccess->dbId);
        // let's make sure it was saved
        $aResult = mysql_query("SELECT $sField FROM oxcontents WHERE oxshopid = '$sShopId' and oxloadid = '$sLoadId'", $this->_oDbAccess->dbId);
        $aRow    = mysql_fetch_array($aResult);

        mysql_close($this->_oDbAccess->dbId);
        
        // $this->logProcess("result: $aResult");
        // $this->logProcess("text: $sText");

        if ($aRow["$sField"] != $sText)
        {
            $this->_sendError('99');
        }
    }

    private function _savePdf($sXml, $sPdfName)
    {
        // we don't implement this at that time with second URL paramenter, because already first check in _checkUrlValid fails 
        if ($this->_checkUrlValid($sXml->rechtstext_pdf_url, '') !== true)
        {
            $this->_sendError('7');
        }

        $sAccountId = $sXml->user_account_id;
        if (is_numeric($sAccountId))
        {
            $sFileShopId = '_'.intval($sAccountId);
        }
        else
        {
            $sFileShopId = '';
        }

        $sFilePdfTarget = './pdf/'.$sPdfName.$sFileShopId.'.pdf';
        $filePdf = @fopen($sFilePdfTarget, "w+");
        if ($filePdf === false)
        {
            $this->_sendError('7');
        }

        if (ini_get('allow_url_fopen') == true)
        {
            $blRetVal = @fwrite($filePdf, @file_get_contents($sXml->rechtstext_pdf_url));
        }
        else
        {
            $blRetVal = @fwrite($filePdf, $this->_fileGetContentsCurl($sXml->rechtstext_pdf_url));
        }
        if ($blRetVal === false)
        {
            $this->_sendError('7');
        }
        $blRetVal = @fclose($filePdf);
        if ($blRetVal === false)
        {
            $this->_sendError('7');
        }
        // catch errors - downloaded file was not properly saved
        if (file_exists($sFilePdfTarget) !== true)
        {
            $this->_sendError('7');
        }

        // verify that file is a pdf
        if ($this->_checkIfPdfFile($sFilePdfTarget) !== true)
        {
            unlink($sFilePdfTarget);
            $this->_sendError('7');
        }

        // verify md5-hash, delete file if hash is not equal
        if (md5_file($sFilePdfTarget) != $sXml->rechtstext_pdf_md5hash)
        {
            unlink($sFilePdfTarget);
            $this->_sendError('8');
        }
    }

    private function _checkIfPdfFile($sFilename)
    {
        $handle   = @fopen($sFilename, "r");
        $contents = @fread($handle, 4);
        @fclose($handle);
        if($contents == '%PDF')
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    private function _checkUrlValid($sUrl, $sLimitToHost = '')
    {
        // $limit_to_host is obsolete and remains as a parameter for compatibility reasons

        // check for allowed URLs
        if ((md5(md5(strtolower(substr($sUrl, 0, 32)))) == 'e8d1c6ea05d248e381301ffff004c0d8') OR
            (md5(md5(strtolower(substr($sUrl, 0, 33)))) == '43f82fb310c6c9f9d4f59a64e194252f') OR
            (strtolower(substr($sUrl, 0, 31)) == 'http://www.it-recht-kanzlei.de/') OR
            (strtolower(substr($sUrl, 0, 32)) == 'https://www.it-recht-kanzlei.de/'))
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    private function _checkUrlValidDeprecated($sUrl, $sLimitToHost = '')
    {
        $arrayUrl = @parse_url($sUrl);
        // check host limit
        if ($sLimitToHost != '')
        {
            if (strtolower($arrayUrl['host']) != strtolower($sLimitToHost)) return false;
        }
        // check HTTP protocol
        if (in_array(strtolower($arrayUrl['scheme']), array('http', 'https')) !== true)
        {
            return false;
        }

        $blRes = filter_var($sUrl, FILTER_VALIDATE_URL);
        if ($blRes !== false)
        {
            return true;
        }
        // check if it has unicode chars
        $l = mb_strlen($sUrl);
        if ($l !== strlen($sUrl))
        {
            // replace wide chars by X
            $sStr = str_repeat (' ', $l);
            for ($i = 0; $i < $l; ++$i)
            {
                $sChars   = mb_substr($sUrl, $i, 1);
                $sStr[$i] = strlen ($sChars) > 1 ? 'X' : $sChars;
            }
            // re-check now
            $blRes = filter_var($sStr, FILTER_VALIDATE_URL);
            if ($blRes !== false )
            {
                return true;
            }
        }
        return false;
    }

    private function _sendError($errorNo)
    {
        $sShopVersion   = $this->_getShopVersion();
        $sModuleVersion = $this->_getModuleVersion();

        header('Content-type: application/xml; charset=utf-8');
        echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        echo "<response>\n";
        echo "  <status>error</status>\n";
        echo "  <error>".$errorNo."</error>\n";
        echo "  <meta_shopversion>".$sShopVersion."</meta_shopversion>";
        echo "  <meta_modulversion>".$sModuleVersion."</meta_modulversion>";
        echo "</response>";
        exit();
    }

    private function _sendSuccess()
    {
        $sShopVersion   = $this->_getShopVersion();
        $sModuleVersion = $this->_getModuleVersion();

        header('Content-type: application/xml; charset=utf-8');
        echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        echo "<response>\n";
        echo "  <status>success</status>\n";
        echo "  <meta_shopversion>".$sShopVersion."</meta_shopversion>";
        echo "  <meta_modulversion>".$sModuleVersion."</meta_modulversion>";
        echo "</response>";
        exit();
    }

    private function _getModuleVersion()
    {
        $sFileName = getShopBasePath().'modules/emitrecht/metadata.php';

        include($sFileName);

        return $aModule["version"];
    }

    private function _getShopVersion()
    {
        // catch any row - EE all sub-shops have to be same version
        $rs = mysql_query("SELECT oxversion FROM oxshops WHERE 1;", $this->_oDbAccess->dbId);
        $sVersion = mysql_result($rs, 0, 0);

        return $sVersion;
    }

    private function _sendShopList()
    {
        header('Content-Type: application/xml; charset=utf-8');
        echo "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
        echo "<accountlist>\n";
        $aResult = mysql_query("SELECT oxid, oxname FROM oxshops WHERE 1;", $this->_oDbAccess->dbId);
        while ($aRow = mysql_fetch_array($aResult))
        {
            echo "  <account>\n";
            echo "    <accountid>".utf8_encode($aRow['oxid'])."</accountid>\n";
            echo "    <accountname>".utf8_encode($this->_specialCharConv($aRow['oxname']))."</accountname>\n";
            echo "  </account>\n";
        }
        echo "</accountlist>";
        mysql_close($this->_oDbAccess->dbId);
        exit();
    }

    private function _specialCharConv($sValue)
    {
        $aReplace = array("&" => "&amp;", "<" => "&lt;", ">" => "&gt;", '"' => "&quot;", "'" => "&apos;");
        foreach ($aReplace as $key => $sReplace)
        {
            $sValue = str_replace($key, $sReplace, $sValue);
        }
        return $sValue;
    }

    private function _fileGetContentsCurl($sUrl)
    {
        $ch = curl_init();

        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);  // set curl to return the data instead of printing it to the browser
        curl_setopt($ch, CURLOPT_URL, $sUrl);

        $data = curl_exec($ch);
        curl_close($ch);

        return $data;
    }

    private function _logProcess($sMessage)
    {
        $sLogFile = getShopBasePath()."modules/emitrecht/process.log";

        $sDate = date("Y-m-d H:i:s", time());

        $fLog = fopen($sLogFile, "a");
        if ($fLog)
        {
            fwrite($fLog, "$sDate: $sMessage \n");
            fclose($fLog);
        }
    }
}


class myDbAccess
{
    protected $dbHost = '';
    protected $dbName = '';
    protected $dbUser = '';
    protected $dbPwd  = '';
    public    $dbId   = null;

    function myDbAccess()
    {
        include("../../config.inc.php");
        $this->dbId = mysql_connect($this->dbHost, $this->dbUser, $this->dbPwd);
        /*
        if ($this->iUtfMode == "1")
        {
            @mysql_query("SET NAMES 'utf8'");
        }
        */
        mysql_select_db($this->dbName, $this->dbId);
    }
}

$oProcessXml = new processXml();
$oProcessXml->start();

?>
